/* *********************************************************************
   Modules 
   ********************************************************************* */

module hexHub(width, thickness)
{
	angle = 360/6;		// 6 surfaces
	cote = width * cot(angle);
	//echo(angle, cot(angle), cote);
	//echo(acos(.6));

		/* The hexagon */
		translate([0, 0, thickness/2]) // center is doof, so heb ichs wenigstens wieder an...
		union()
		{
			// Rechtecke, um 1/6 Kreis verdreht
			rotate([0, 0, 0]) 		cube([width, cote, thickness], center=true);
			rotate([0, 0, angle])	cube([width, cote, thickness], center=true);
			rotate([0, 0, 2*angle])	cube([width, cote, thickness], center=true);
		}
}

//------------------------------------------------------------
// Fonction cotangente
// Permet d'avoir les bones dimensions
// utiliser $fn n'est pas bon
//------------------------------------------------------------
function cot(x)=1/tan(x);



module triangle (b, h, w)
{ // http://www.iheartrobotics.com/2011/02/openscad-tip-round-2-of-3.html
/*b = 10;
h = 100;
w = 4;
	*/

	// extruded triangle
	rotate(a=[90,-90,0])
	linear_extrude(height = w, center = true, convexity = 10, twist = 0)
	polygon(points=[[0,0],[h,0],[0,b]], paths=[[0,1,2]]);

}

module triangle2 (b, w, h)
{ // http://www.iheartrobotics.com/2011/02/openscad-tip-round-2-of-3.html
/*b = 10;
h = 100;
w = 4;
	*/

	// extruded triangle
	//rotate(a=[90,-90,0])
	//translate([0, 0, h/2])
	linear_extrude(height = h, center = false, convexity = 10, twist = 0)
	polygon(
		points=
			[[0,0], 	// Ursprung
			[b/2,w], 	// Mittlere Spitze 
			[b,0]], 
		paths=[[0,1,2]]);

}

/**************
 * Langlöcher *
 **************
	Please note: Langlöcher are centered in origin's hole's center 
*/
module langLoch(d, l, h)
{
	langLoch3D(d, l, h);
}

module langLoch3D(d, l, h)
{
	linear_extrude(height=h)
	langLoch2D(d, l);
}

module langLoch2D(d, l)
{
	ls=l-d/2*2;
//	echo ("ls: ", ls);
	union()
	{
		circle(d=d);

		translate([l-(d/2)*2, 0, 0])
		circle(d=d);
	
		translate([ls/2, 0, 0])
		square([ls, d], center=true);
	}

/*	if (h==undef)
	{
		echo("This has a height, so extrude it! ", h);
		
	}*/
}

/**************
 *   Zapfen   *
 **************

/* d=diameter, h=height (inkl. Verrundung), ho=offset (z, height) of hole, hd=hole diameter */
module zapfenMitLoch(d, h, ho, hd)
{
	difference()
	{
		zapfen(d, h);
	
		translate([-d/2, 0, ho])
		rotate([0, 90, 0])
		cylinder(d=hd, h=d);
	}
}

module zapfen(d, h)
{
	r=d/2;
	
	union()
	{
		cylinder(d=d, h=h-r, center=false);
		translate([0, 0, h-r])
		sphere(d=d);
	}
}


/* **************
   * 5 x 7 Text *
   **************
		Basierend auf http://www.thingiverse.com/thing:59817/#files von pgreenland
*/
module draw5by7Text(text, height)
{
	//Characters
	chars = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}";

	//Chracter table defining 5x7 characters
	//Adapted from: http://www.geocities.com/dinceraydin/djlcdsim/chartable.js
	char_table = [ [ 0, 0, 0, 0, 0, 0, 0],
                  [ 4, 0, 4, 4, 4, 4, 4],
                  [ 0, 0, 0, 0,10,10,10],
                  [10,10,31,10,31,10,10],
                  [ 4,30, 5,14,20,15, 4],
                  [ 3,19, 8, 4, 2,25,24],
                  [13,18,21, 8,20,18,12],
                  [ 0, 0, 0, 0, 8, 4,12],
                  [ 2, 4, 8, 8, 8, 4, 2],
                  [ 8, 4, 2, 2, 2, 4, 8],
                  [ 0, 4,21,14,21, 4, 0],
                  [ 0, 4, 4,31, 4, 4, 0],
                  [ 8, 4,12, 0, 0, 0, 0],
                  [ 0, 0, 0,31, 0, 0, 0],
                  [12,12, 0, 0, 0, 0, 0],
                  [ 0,16, 8, 4, 2, 1, 0],
                  [14,17,25,21,19,17,14],
                  [14, 4, 4, 4, 4,12, 4],
                  [31, 8, 4, 2, 1,17,14],
                  [14,17, 1, 2, 4, 2,31],
                  [ 2, 2,31,18,10, 6, 2],
                  [14,17, 1, 1,30,16,31],
                  [14,17,17,30,16, 8, 6],
                  [ 8, 8, 8, 4, 2, 1,31],
                  [14,17,17,14,17,17,14],
                  [12, 2, 1,15,17,17,14],
                  [ 0,12,12, 0,12,12, 0],
                  [ 8, 4,12, 0,12,12, 0],
                  [ 2, 4, 8,16, 8, 4, 2],
                  [ 0, 0,31, 0,31, 0, 0],
                  [16, 8, 4, 2, 4, 8,16],
                  [ 4, 0, 4, 2, 1,17,14],
                  [14,21,21,13, 1,17,14],
                  [17,17,31,17,17,17,14],
                  [30,17,17,30,17,17,30],
                  [14,17,16,16,16,17,14],
                  [30,17,17,17,17,17,30],
                  [31,16,16,30,16,16,31],
                  [16,16,16,30,16,16,31],
                  [15,17,17,23,16,17,14],
                  [17,17,17,31,17,17,17],
                  [14, 4, 4, 4, 4, 4,14],
                  [12,18, 2, 2, 2, 2, 7],
                  [17,18,20,24,20,18,17],
                  [31,16,16,16,16,16,16],
                  [17,17,17,21,21,27,17],
                  [17,17,19,21,25,17,17],
                  [14,17,17,17,17,17,14],
                  [16,16,16,30,17,17,30],
                  [13,18,21,17,17,17,14],
                  [17,18,20,30,17,17,30],
                  [30, 1, 1,14,16,16,15],
                  [ 4, 4, 4, 4, 4, 4,31],
                  [14,17,17,17,17,17,17],
                  [ 4,10,17,17,17,17,17],
                  [10,21,21,21,17,17,17],
                  [17,17,10, 4,10,17,17],
                  [ 4, 4, 4,10,17,17,17],
                  [31,16, 8, 4, 2, 1,31],
                  [14, 8, 8, 8, 8, 8,14],
                  [ 0, 1, 2, 4, 8,16, 0],
                  [14, 2, 2, 2, 2, 2,14],
                  [ 0, 0, 0, 0,17,10, 4],
                  [31, 0, 0, 0, 0, 0, 0],
                  [ 0, 0, 0, 0, 2, 4, 8],
                  [15,17,15, 1,14, 0, 0],
                  [30,17,17,25,22,16,16],
                  [14,17,16,16,14, 0, 0],
                  [15,17,17,19,13, 1, 1],
                  [14,16,31,17,14, 0, 0],
                  [ 8, 8, 8,28, 8, 9, 6],
                  [14, 1,15,17,15, 0, 0],
                  [17,17,17,25,22,16,16],
                  [14, 4, 4, 4,12, 0, 4],
                  [12,18, 2, 2, 2, 6, 2],
                  [18,20,24,20,18,16,16],
                  [14, 4, 4, 4, 4, 4,12],
                  [17,17,21,21,26, 0, 0],
                  [17,17,17,25,22, 0, 0],
                  [14,17,17,17,14, 0, 0],
                  [16,16,30,17,30, 0, 0],
                  [ 1, 1,15,19,13, 0, 0],
                  [16,16,16,25,22, 0, 0],
                  [30, 1,14,16,15, 0, 0],
                  [ 6, 9, 8, 8,28, 8, 8],
                  [13,19,17,17,17, 0, 0],
                  [ 4,10,17,17,17, 0, 0],
                  [10,21,21,17,17, 0, 0],
                  [17,10, 4,10,17, 0, 0],
                  [14, 1,15,17,17, 0, 0],
                  [31, 8, 4, 2,31, 0, 0],
                  [ 2, 4, 4, 8, 4, 4, 2],
                  [ 4, 4, 4, 4, 4, 4, 4],
                  [ 8, 4, 4, 2, 4, 4, 8] ];

	//Binary decode table
	dec_table = [ "00000", "00001", "00010", "00011", "00100", "00101",
  	            "00110", "00111", "01000", "01001", "01010", "01011",
  	            "01100", "01101", "01110", "01111", "10000", "10001",
  	            "10010", "10011", "10100", "10101", "10110", "10111",
	            "11000", "11001", "11010", "11011", "11100", "11101",
	            "11110", "11111" ];

	//Process string one character at a time
	for(itext = [0:len(text)-1]) {
		//Convert character to index
		assign(ichar = search(text[itext],chars,1)[0]) {
			//Decode character - rows
			for(irow = [0:6]) {
				assign(val = dec_table[char_table[ichar][irow]]) {
					//Decode character - cols
					for(icol = [0:4]) {
						assign(bit = search(val[icol],"01",1)[0]) {
							if(bit) {
								//Output cube
								translate([icol + (6*itext), irow, 0])
									cube([1.0001,1.0001, height]);
							}
						}
					}
				}
			}
		}
	}
}

